<?php
/*
+--------------------------------------------------------------------------
|   ========================================
|   Avatar Random 3
|   ========================================
|   by Newsboard Forum
|   (c) 2009 - 2010
|   ========================================
|   http://newsboard.forumfree.it
|   ========================================
+--------------------------------------------------------------------------
*/

error_reporting(E_ALL);
set_magic_quotes_runtime(0);

//============================================================
// COSTANTS
//============================================================

// Public directory //////////////////////////////////////////
define('ROOT_PATH', dirname(__FILE__) . '/');

// Upload directory //////////////////////////////////////////
define('UPLOAD_DIR', 'upload_ar3/');

//============================================================
// CLEAN REQUEST
//============================================================

if (get_magic_quotes_gpc())
{
	$_GET		= stripslashes_deep( $_GET );
	$_POST		= stripslashes_deep( $_POST );
	$_COOKIE	= stripslashes_deep( $_COOKIE );
}

$_REQUEST = array_merge( $_GET, $_POST );

//============================================================
// FUNCTION
//============================================================

/**
 * If already slashed, strip.
 */
function stripslashes_deep($value)
{
	return is_array($value) ? array_map('stripslashes_deep', $value) : stripslashes($value);
}

/**
 * Extensions allowed?
 */
function validFileType($filename)
{
	if (in_array(strtolower(substr(strrchr($filename, '.'), 1)), array('jpg', 'png', 'gif', 'jpeg')))
		return true;
	else
		return false;
}

/**
 * Set tpl vars.
 */
function assign_var($tpl_var, $value = null)
{
	if (is_array($tpl_var))
	{
		foreach ($tpl_var as $key => $val)
		{
			if ($key != '')
			{
				$GLOBALS['tpl'][$key] = $val;
			}
		}
	}
	else
	{
		if ($tpl_var != '')
		{
			$GLOBALS['tpl'][$tpl_var] = $value;
		}
	}
}

/**
 * Output
 */
function display_page($tpl_name)
{
	$theme_func = 'theme_' . $tpl_name;

	if (function_exists($theme_func))
	{
		theme_header();

		$theme_func();

		theme_footer();
	}
	else
	{
		echo 'template non definito';
	}
}

//============================================================
// PAGE
//============================================================

/**
 * Page - Installation
 */
function av3_install()
{
	$error = array();

	if (isset($_REQUEST['ar3_password']))
	{
		$password = (string) $_REQUEST['ar3_password'];

		if (!(preg_match("/^[a-zA-Z0-9_]{6,28}$/", $password)))
		{
			$error[] = 'Password non valida.';
		}

		if (!sizeof($error))
		{
			$dir = ROOT_PATH . UPLOAD_DIR;

			if (!file_exists($dir))
			{
				@mkdir($dir, 0777);
			}

			if (!is_writable($dir))
			{
				if (!is_dir($dir))
				{
					$error[] = 'La cartella <b>' . UPLOAD_DIR . '</b> non esiste.';
				}
				else
				{
					$error[] = 'La cartella <b>' . UPLOAD_DIR . '/</b> necessita dei permessi di scrittura!';
				}
			}
		}

		if (!sizeof($error))
		{
			$psw = md5($password);
			$key = substr(md5(mt_rand()), 0, 12);

			$config_data = "<?php\n";
			$config_data .= "define('PSW', '{$psw}');\n";
			$config_data .= "define('KEY', '{$key}');\n";
			$config_data .= '?' . '>';

			if ($fd = @fopen(ROOT_PATH . 'config.php', 'wb'))
			{
				fwrite($fd, $config_data);
				fclose($fd);
			}
			else
			{
				$error[] = 'Installazione fallita.';
			}
		}

		assign_var('S_INSTALL', true);
	}

	assign_var(array(
		'S_ERROR'	=> (sizeof($error)) ? true : false,
		'ERROR_MSG'	=> (sizeof($error)) ? implode('<br />', $error) : '',
	));

	display_page('install');
}

/**
 * Page - Login
 */
function av3_login()
{
	if (isset($_POST['ar3_psw']))
	{
		$psw = md5(trim((string) $_POST['ar3_psw']));

		if (PSW == $psw)
		{
			setcookie(KEY, $psw);
			echo '<html><head><meta http-equiv="refresh" content="0; url=index.php?login"></head><body></body></html>';
			exit;
		}
		else
		{
			assign_var('S_ERROR', true);
		}
	}

	display_page('login');
}

/**
 * Page - Load image
 */
function av3_load()
{
	$error = array();

	if (isset($_FILES['attachment']['name']) && $_FILES['attachment']['name'] != '')
	{
		if (isset($_REQUEST['key']) && $_REQUEST['key'] == KEY)
		{
			if (!is_uploaded_file($_FILES['attachment']['tmp_name']) || (@ini_get('open_basedir') == '' && !file_exists($_FILES['attachment']['tmp_name'])))
			{
				$error[] = 'Il file non  stato caricato correttamente.';
			}

			if (!sizeof($error))
			{
				$_FILES['attachment']['name'] = preg_replace(array('/\s/', '/\.[\.]+/', '/[^\w_\.\-]/'), array('_', '.', ''), $_FILES['attachment']['name']);

				if (!validFileType($_FILES['attachment']['name']))
				{
					$error[] = 'Il file ha una estensione non valida.';
				}

				if ($_FILES['attachment']['size'] < 10 || $_FILES['attachment']['size'] > 60000)
				{
					$error[] = 'Il file ha superato i limiti di peso consentiti.';
				}
			}

			if (!sizeof($error))
			{
				if (!is_writable(ROOT_PATH . UPLOAD_DIR))
				{
					$error[] = 'La cartella <b>' . UPLOAD_DIR . '</b> non esiste o non pu essere utilizzata.';
				}
			}

			if (!sizeof($error))
			{
				$destFile = ROOT_PATH . UPLOAD_DIR . 'ar3_' . time() . '_' . basename($_FILES['attachment']['name']);
				if (!move_uploaded_file($_FILES['attachment']['tmp_name'], $destFile))
				{
					$error[] = 'Upload fallito.';
				}
				else
				{
					@chmod($destFile, 0644);
				}
			}
		}
		else
		{
			$error[] = 'Dati corrotti, riprova di nuovo.';
		}
	}
	else
	{
		$error[] = 'Non  stato selezionato alcun file da caricare.';
	}

	assign_var(array(
		'S_ERROR'	=> (sizeof($error)) ? true : false,
		'ERROR_MSG'	=> (sizeof($error)) ? implode('<br />', $error) : '',
	));

	display_page('load');
}

/**
 * Page - Main
 */
function av3_main()
{
	$image_file = array();

	if (is_dir(ROOT_PATH . UPLOAD_DIR) && $handle = opendir(ROOT_PATH . UPLOAD_DIR))
	{
		while (false !== ($file = readdir($handle)))
		{
			if (in_array($file, array('.', '..')))
				continue;

			if (is_file(ROOT_PATH . UPLOAD_DIR . $file) && validFileType($file))
			{
				$image_file[] = $file;
			}
		}

		closedir($handle);
	}

	if (isset($_REQUEST['update']))
	{
		if ($fd = @fopen(ROOT_PATH . UPLOAD_DIR . 'ar3_list.php', 'wb'))
		{
			assign_var('UPDATE', true);
			fwrite($fd, '<?php $list_avy = \'' . addslashes(serialize($image_file)) . '\'; ?>');
			fclose($fd);
		}
	}
	elseif (isset($_REQUEST['canc']) && in_array($_REQUEST['canc'], $image_file))
	{
		@unlink(ROOT_PATH . UPLOAD_DIR . $_REQUEST['canc']);
		header('Location: index.php?del');
		exit;
	}

	assign_var(array(
		'NAV'		=> true,
		'IMAGE'		=> $image_file,
		'DIRECTORY'	=> UPLOAD_DIR,
		'UP_KEY'	=> KEY,
	));

	display_page('main');
}

/**
 * Page - Url
 */
function av3_links()
{
	$server_name = (!empty($_SERVER['HTTP_HOST'])) ? strtolower($_SERVER['HTTP_HOST']) : ((!empty($_SERVER['SERVER_NAME'])) ? $_SERVER['SERVER_NAME'] : getenv('SERVER_NAME'));
	$script_name = (!empty($_SERVER['PHP_SELF'])) ? $_SERVER['PHP_SELF'] : getenv('PHP_SELF');
	$url_base = 'http://' . preg_replace('#[\\\\/]{2,}#', '/', $server_name . trim(dirname($script_name)) . '/');

	$url_normal	= $url_pro = array();

	$url_normal[] = $url_base . 'avatar.php?image.png';
	$url_normal[] = $url_base . 'avatar.php?avatar.gif';
	$url_normal[] = $url_base . 'avatar.php?newsboard_forum.jpeg';

	$url_pro[] = $url_base . 'ar3_avatar.gif';
	$url_pro[] = $url_base . 'ar3_newsboard_forum.png';
	$url_pro[] = $url_base . 'ar3_forumfree.jpeg';

	if (!file_exists(ROOT_PATH . '.htaccess'))
	{
		if (isset($_REQUEST['install']))
		{
			if (isset($_REQUEST['install_key']) && $_REQUEST['install_key'] == KEY)
			{
				if (($fp = @fopen(ROOT_PATH . '.htaccess', 'w')) && fputs($fp, "<IfModule mod_rewrite.c>\nRewriteEngine on\nRewriteRule ^ar3_([^/]+)\.(jpeg|jpg|gif|png)$ avatar.php [L]\n</IfModule>"))
				{
					fclose($fp);
					@chmod(ROOT_PATH . '.htaccess', 0664);
					header('Location: index.php?p=links');
					exit;
				}
			}
		}
		assign_var('INSTALL', true);
	}

	assign_var(array(
		'NAV'			=> true,
		'URL_NORMAL'	=> $url_normal,
		'URL_PRO'		=> $url_pro,
		'KEY'			=> KEY,
	));

	display_page('links');
}

//============================================================
// TEMPLATE
//============================================================

/**
 * Template => Installation
 */
function theme_install()
{
	echo '<h2>Installazione Avatar Random 3</h2>';

	if (isset($GLOBALS['tpl']['S_INSTALL']) && !$GLOBALS['tpl']['S_ERROR'])
	{
		echo '<div class="ok">Installazione completata! <a href="index.php">Procedi >></a></div>';
	}
	else
	{
		if ($GLOBALS['tpl']['S_ERROR'])
		{
			echo '<div class="error">' . $GLOBALS['tpl']['ERROR_MSG'] . '</div>';
		}
		echo '<form action="index.php" method="POST">Inserisci una password da utilizzare in futuro per gestire il tuo avatar: <input type="text" name="ar3_password" value=""> <input type="submit" value="Installa"></form>';
	}
}

/**
 * Template => Login
 */
function theme_login()
{
	echo '<h2>Accedi</h2>';

	if (isset($GLOBALS['tpl']['S_ERROR']))
	{
		echo '<div class="error">Password errata.</div>';
	}

	echo '<form action="index.php" method="POST"><p>Inserisci la tua password: <input type="password" name="ar3_psw" value=""> <input type="submit" value="Login"></p></form>';
}

/**
 * Template => Main
 */
function theme_main()
{
	echo '<h2>Carica immagine</h2><form action="index.php?p=load" method="post" enctype="multipart/form-data"><p><input type="file" size="36" name="attachment" value=""><input type="hidden" name="key" value="' . $GLOBALS['tpl']['UP_KEY'] . '"> <input type="submit" value="Upload!"></p></form>';

	echo '<h2>Aggiorna lista</h2><form action="index.php?p=main" method="POST"><p align="center">Quando aggiungi o elimini una o pi immagini dal tuo album  necessario aggiornare la lista degli avatar utilizzabili affinch le modifiche siano registrate. Puoi farlo cliccando sul tasto qui in basso.<br>' . ((isset($GLOBALS['tpl']['UPDATE'])) ? '<b>Lista aggiornata!</b>' : '<input type="submit" name="update" value="Aggiorna la lista degli avatar utilizzabili">') . '</p></form>';

	echo '<h2>Album</h2>';
	if (sizeof($GLOBALS['tpl']['IMAGE']))
	{
		foreach ($GLOBALS['tpl']['IMAGE'] as $img)
		{
			$img = htmlentities($img, ENT_QUOTES);
			echo '<span style="padding:5px;"><a href="index.php?p=main&canc=' . $img . '" onclick="if(!confirm(\'Desideri cancellare questa immagine?\')) return false;"><img src="' . $GLOBALS['tpl']['DIRECTORY'] . $img . '" alt="" style="border:5px solid #000000;"></a></span>';
		}
	}
	else
	{
		echo '<p align="center">Album vuoto</p>';
	}
}


/**
 * Template => Load
 */
function theme_load()
{
	echo '<h2>Carica immagine</h2>';
	if (!$GLOBALS['tpl']['S_ERROR'])
		echo '<div class="ok">Upload completato.</div>';
	else
		echo '<div class="error">' . $GLOBALS['tpl']['ERROR_MSG'] . '</div>';
	echo '<form method="get" action="index.php"><input value="Torna indietro" type="submit"></form>';
}

/**
 * Template => Links
 */
function theme_links()
{
	echo '<h2>URL Normal</h2>';
	foreach ($GLOBALS['tpl']['URL_NORMAL'] as $url_normal)
	{
		echo '<div class="ok"><i>' . $url_normal . '</i></div>';
	}
	echo '<h2>URL Pro</h2>';
	foreach ($GLOBALS['tpl']['URL_PRO'] as $url_pro)
	{
		echo '<div class="' . ((isset($GLOBALS['tpl']['INSTALL'])) ? 'error' : 'ok') . '"><i>' . $url_pro . '</i></div>';
	}

	if (isset($GLOBALS['tpl']['INSTALL']))
	{
		echo '<form action="index.php?p=links" method="POST"><p>L\'utilizzo degli URL Pro necessitano del modulo <b>mod_rewrite</b> attivo. <input type="hidden" name="install_key" value="' . $GLOBALS['tpl']['KEY'] . '"><input name="install" type="submit" value="Installa"></p></form>';
	}
}

/**
 * Template => Header
 */
function theme_header()
{
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>Avatar Random 3</title> <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" /> <style type="text/css">* { margin: 0; padding: 0; } body { background: #333; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; color: #666; } a { text-decoration: none; color: #CC0001; } a:hover { text-decoration: underline; color: #666;} ul { list-style-type: none; margin: 0; padding-left: 0px; } ul li { padding: 0 0 3px 0; border-bottom: 1px dotted #000; } ul li a:hover { text-decoration: none; color: #000; } img { border: none; } #wrap { margin: 0px auto; width: 780px; background: #fff; padding: 10px; } #menu {margin-top: 10px; margin-bottom: 10px; height: 30px;line-height: 30px;background: #CC0001;} #menu ul {list-style-type: none;padding-left: 10px;} #menu ul li {display: block;float: left;border: none;} #menu ul li a {padding: 0 20px 0 0;text-decoration: none;font-weight: 600;color: #fff;} #menu ul li a:hover {color: #fff;text-decoration: underline;} #left {padding: 10px;text-align: justify;} #left h2 { color: #000;font-size: 17px;font-weight: 100;letter-spacing: -1px;} #left .error { margin: 6px; padding:8px; color:#bb1111; background-color:#dd8888; } #left .ok { margin: 6px; padding:8px; color:#0077ee; background-color:#99bbcc;}</style></head><body><div id="wrap">';

	if (isset($GLOBALS['tpl']['NAV']))
	{
		echo '<div id="menu"><ul><li><a href="index.php?p=main">Gestione avatar</a></li><li><a href="index.php?p=links">Links</a></li></ul></div>';
	}

	echo '<div id="left">';
}

/**
 * Template => Footer
 */
function theme_footer()
{
	echo '</div></div></body></html>';
}

//============================================================
// RUN!
//============================================================

if (file_exists(ROOT_PATH . 'config.php'))
{
	include(ROOT_PATH . 'config.php');
}

$tpl = array();

//-------------------------------
// What function shall we execute?
//-------------------------------
if (!defined('PSW') || !defined('KEY'))
{
	av3_install();
}
else
{
	$psw = isset($_COOKIE[KEY]) ? (string) $_COOKIE[KEY] : '';

	if (PSW == $psw)
	{
		$page = (isset($_GET['p'])) ? (string) $_GET['p'] : '';

		switch ($page)
		{
			case 'load':
				av3_load();
			break;

			case 'links':
				av3_links();
			break;

			default:
				av3_main();
		}
	}
	else
	{
		av3_login();
	}
}

?>